<template>
  <a-modal
    :title="title"
    :width="width"
    :visible="visible"
    :confirmLoading="confirmLoading"
    @ok="handleOk"
    @cancel="handleCancel"
    cancelText="关闭">
    <a-spin :spinning="confirmLoading">
      <a-form :form="form">

        <a-form-item label="服务商" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <template v-if="!model.id">
            <a-input-search
              placeholder="选择服务商"
              disabled
              v-decorator="[ 'subcontractorName', validatorRules.subcontractorId]"
              @search="onSearch">
              <a-button slot="enterButton" icon="search" v-if="!model.id">选择</a-button>
            </a-input-search>
          </template>
          <template v-else>
            <a-input v-decorator="[ 'subcontractorName', {rules: [{ required: true, message: '请选择服务商' }],initialValue:model.subcontractorName}]"  :disabled="true"></a-input>
          </template>
        </a-form-item>
          
        <a-form-item label="开户行" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input v-decorator="[ 'bankName', validatorRules.bankName]" placeholder="请输入开户行"></a-input>
        </a-form-item>
          
        <a-form-item label="开户地" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input v-decorator="[ 'bankAddress', validatorRules.bankAddress]" placeholder="请输入开户地"></a-input>
        </a-form-item>
          
        <a-form-item label="账户" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input v-decorator="[ 'bankAccount', validatorRules.bankAccount]" placeholder="请输入账户" style="width: 100%"></a-input>
        </a-form-item>
          
        
      </a-form>
    </a-spin>
   <subcontractor-window ref="subcontractorWindow" @ok="modalFormOk"></subcontractor-window>
  </a-modal>
</template>

<script>

  import { httpAction } from '@/api/manage'
  import pick from 'lodash.pick'
  import SubcontractorWindow from '../../hlgplatform/modules/SubcontractorWindow'

  
  export default {
    name: "HlgSubcontractorBankInformationModal",
    components: {
      SubcontractorWindow

    },
    data () {
      return {
        selectedDepartKeys:[], //保存用户选择服务商id
        checkedDepartKeys:[],
        form: this.$form.createForm(this),
        title:"操作",
        width:800,
        visible: false,
        model: {},
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },

        confirmLoading: false,
        validatorRules:{
        subcontractorId:{rules: [{ required: true, message: '请输入所属服务商!' }]},
        bankName:{rules: [{ required: true, message: '请输入开户行!' }]},
        bankAddress:{rules: [{ required: true, message: '请输入开户地!' }]},
        bankAccount:{rules: [{ required: true, message: '请输入账户!' },{ validator: this.validateAbbreviation }]},
        },
        url: {
          add: "/hlgsubcontractor/hlgSubcontractorBankInformation/add",
          edit: "/hlgsubcontractor/hlgSubcontractorBankInformation/edit",
        }
     
      }
    },
    created () {
    },
    methods: {
      add () {

        this.edit({});
      },
      edit (record) {
        this.form = this.$form.createForm(this)
        this.form.resetFields();
        this.model = Object.assign({}, record);
        this.visible = true;
        this.selectedDepartKeys = [];
        this.checkedDepartKeys = [];
        this.$nextTick(() => {
          this.form.setFieldsValue(pick(this.model,'subcontractorId','bankName','bankAddress','bankAccount','subcontractorName'))
        })
      },
      close () {
        this.$emit('close');
        this.visible = false;
        this.selectedDepartKeys = [];
        this.checkedDepartKeys = [];
      },
      handleOk () {
        const that = this;
        // 触发表单验证
        this.form.validateFields((err, values) => {
          if (!err) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            let formData = Object.assign(this.model, values);
            if(this.selectedDepartKeys[0]){
              formData.subcontractorId = this.selectedDepartKeys[0];
            }
            console.log("表单提交数据",formData)
            httpAction(httpurl,formData,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
              that.close();
            })
          }
         
        })
      },
      handleCancel () {
        this.close()
      },
      popupCallback(row){
        this.form.setFieldsValue(pick(row,'subcontractorId','bankName','bankAddress','bankAccount'))
      },
      //搜索服务商
      onSearch(){
        this.$refs.subcontractorWindow.add(this.checkedDepartKeys);
      },
      // 获取用户选择服务商弹提交的返回数据
      modalFormOk (formData) {
        this.selectedDepartKeys = [];
        for (let i = 0; i < formData.departIdList.length; i++) {
          this.selectedDepartKeys.push(formData.departIdList[i].key);
          this.form.setFieldsValue({ subcontractorName: formData.departIdList[i].title })
        }
        this.checkedDepartKeys = this.selectedDepartKeys  //更新当前的选择keys
      },


      //校验只能为数字
      validateAbbreviation(rule, value, callback) {
        if (!value) {
          callback()
        } else {
          if (new RegExp(/^[0-9]*$/).test(value)) {
            callback()
          } else {
            callback('请输入数字!')
          }
        }

      },


    }
  }
</script>